"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EthereumPlugin = void 0;
/* eslint-disable import/no-extraneous-dependencies */
var resolvers_1 = require("./resolvers");
var manifest_1 = require("./manifest");
var core_js_1 = require("@web3api/core-js");
var ethers_1 = require("ethers");
var providers_1 = require("@ethersproject/providers");
var address_1 = require("@ethersproject/address");
var EthereumPlugin = /** @class */ (function (_super) {
    __extends(EthereumPlugin, _super);
    function EthereumPlugin(_config) {
        var _this = _super.call(this) || this;
        _this._config = _config;
        var provider = _config.provider, signer = _config.signer;
        // Sanitize Provider & Signer
        _this.setProvider(provider, signer !== undefined ? signer : 0);
        return _this;
    }
    EthereumPlugin.manifest = function () {
        return manifest_1.manifest;
    };
    // TODO: generated types here from the schema.graphql to ensure safety `Resolvers<TQuery, TMutation>`
    // https://github.com/Web3-API/prototype/issues/101
    EthereumPlugin.prototype.getModules = function (_client) {
        return {
            query: resolvers_1.query(this),
            mutation: resolvers_1.mutation(this),
        };
    };
    EthereumPlugin.prototype.setProvider = function (provider, signer) {
        this._config.provider = provider;
        if (typeof provider === "string") {
            this._client = new providers_1.JsonRpcProvider(provider);
        }
        else {
            this._client = new providers_1.Web3Provider(provider);
        }
        if (signer !== undefined) {
            this.setSigner(signer);
        }
    };
    EthereumPlugin.prototype.setSigner = function (signer) {
        if (typeof signer === "string") {
            this._config.signer = address_1.getAddress(signer);
        }
        else if (ethers_1.Signer.isSigner(signer)) {
            this._config.signer = signer;
            if (signer.provider !== this._config.provider) {
                throw Error("Signer's connected provider does not match the config's " +
                    "provider. Please call \"setProvider(...)\" before calling " +
                    "\"setSigner(...)\" if a different provider is desired.");
            }
        }
        else {
            this._config.signer = signer;
        }
    };
    EthereumPlugin.prototype.getSigner = function () {
        var signer = this._config.signer;
        if (this._config.signer === undefined) {
            throw Error("Signer is undefined, this should never happen.");
        }
        if (typeof signer === "string" || typeof signer === "number") {
            return this._client.getSigner(signer);
        }
        else if (ethers_1.Signer.isSigner(signer)) {
            return signer;
        }
        else {
            throw Error("Signer is an unrecognized type, this should never happen. \n" + signer);
        }
    };
    EthereumPlugin.prototype.getContract = function (address, abi) {
        return new ethers_1.ethers.Contract(address, abi, this.getSigner());
    };
    EthereumPlugin.prototype.deployContract = function (abi, bytecode) {
        var args = [];
        for (var _i = 2; _i < arguments.length; _i++) {
            args[_i - 2] = arguments[_i];
        }
        return __awaiter(this, void 0, void 0, function () {
            var signer, factory, contract;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        signer = this.getSigner();
                        factory = new ethers_1.ethers.ContractFactory(abi, bytecode, signer);
                        return [4 /*yield*/, factory.deploy.apply(factory, args)];
                    case 1:
                        contract = _a.sent();
                        return [4 /*yield*/, contract.deployTransaction.wait()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, contract.address];
                }
            });
        });
    };
    EthereumPlugin.prototype.callView = function (address, method, args) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, funcs, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = this.getContract(address, [method]);
                        funcs = Object.keys(contract.interface.functions);
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, args)];
                    case 1:
                        res = _a.sent();
                        return [2 /*return*/, res.toString()];
                }
            });
        });
    };
    EthereumPlugin.prototype.sendTransaction = function (address, method, args) {
        return __awaiter(this, void 0, void 0, function () {
            var contract, funcs, tx, res;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        contract = this.getContract(address, [method]);
                        funcs = Object.keys(contract.interface.functions);
                        return [4 /*yield*/, contract[funcs[0]].apply(contract, args)];
                    case 1:
                        tx = _a.sent();
                        return [4 /*yield*/, tx.wait()];
                    case 2:
                        res = _a.sent();
                        // TODO: improve this
                        return [2 /*return*/, res.transactionHash];
                }
            });
        });
    };
    return EthereumPlugin;
}(core_js_1.Plugin));
exports.EthereumPlugin = EthereumPlugin;
//# sourceMappingURL=index.js.map